IMPLICIT NONE

integer*2, parameter :: ncol=100, nlin=95
integer*8, dimension(ncol,nlin) :: idata
integer*8, dimension(ncol-1,6) :: idata2
integer*2 :: jj

open(11,file='depts_details3.csv',form='formatted')

idata2(:,:) = 0
do jj=1,nlin

  read(11,*) idata(:,jj)

  if (jj==1) then
    idata2(1:ncol-1,1) = idata(1:ncol-1,1)
  else
    idata2(1:ncol-1,idata(ncol,jj)+2) = idata2(1:ncol-1,idata(ncol,jj)+2) + idata(1:ncol-1,jj)
  endif

enddo
close(11)

do jj=1,ncol-1
  idata2(jj,4:6) = nint( idata2(jj,4:6) * 100. / sum(idata2(jj,4:6)) )
enddo

open(11,file='depts_types_cultures.csv',form='formatted')
do jj=1,ncol-1
  write(11,fmt=*) idata2(jj,1),idata2(jj,4:6)
enddo
close(11)

open(12,file='recode_depts_c3h.txt',form='formatted')
open(13,file='recode_depts_c3e.txt',form='formatted')
open(14,file='recode_depths_c4.txt',form='formatted')
do jj=1,ncol-1
  write(12,fmt='(i3.3,a1,i3.3,a1,i3.3,a1,i3.3)') idata2(jj,1),":",idata2(jj,1),":",idata2(jj,4),":",idata2(jj,4)
  write(13,fmt='(i3.3,a1,i3.3,a1,i3.3,a1,i3.3)') idata2(jj,1),":",idata2(jj,1),":",idata2(jj,5),":",idata2(jj,5)
  write(14,fmt='(i3.3,a1,i3.3,a1,i3.3,a1,i3.3)') idata2(jj,1),":",idata2(jj,1),":",idata2(jj,6),":",idata2(jj,6)
enddo
close(12)
close(13)
close(14)

      END
