IMPLICIT NONE

!ninter doit être pair
integer*4, parameter :: ncols=360,nrows=180,ninter1=6, ninter2=20, niter=10
integer*4 :: ji, jj, j1, j2, j3, i0, j0, jinter, jiter
integer*1, dimension(ncols) :: iline,iline2, iline3out
integer*1,dimension(ncols,ninter2) :: iline3in
integer :: icptfd, icptfs, icptcs, icptcd
integer*2 :: iinter
character(len=53) :: yname1, yname2, yname3

yname1 = 'ecosg_foret_tot_1d'
yname2 = 'ecosg_foret_tot_1db.bin'
yname3 = 'ecosg_foret_tot_1dc.bin'

!ceux qui se touchent

!en descendant
!open(11,file=yname1,form='unformatted',access='direct',recl=ncols)
!open(12,file=yname2,form='unformatted',access='direct',recl=ncols)
!
!read(11,rec=1) iline
!
!call find_gauche_droite(iline)
!write(12,rec=1) iline
!
!do jj=2,nrows
!  print*,'jrow ',jj
!  read(11,rec=jj) iline2
!
!  do ji=1,ncols
!    if (iline2(ji)==4) then
!      if (iline(ji)==1 .or. iline(ji)==3) iline2(ji) = iline(ji)
!    endif
!  enddo
!
!  call find_gauche_droite(iline2)  
!  write(12,rec=jj) iline2
!  iline = iline2
! 
!enddo
!
!close(11)
!close(12)

!!en montant
!open(11,file=yname2,form='unformatted',access='direct',recl=ncols)
!open(12,file=yname3,form='unformatted',access='direct',recl=ncols)
!
!read(11,rec=nrows) iline
!
!call find_gauche_droite(iline)
!write(12,rec=nrows) iline
!
!do jj=nrows-1,1,-1
!  read(11,rec=jj) iline2
!
!  do ji=1,ncols
!    if (iline2(ji)==4) then
!      if (iline(ji)==1 .or. iline(ji)==3) iline2(ji) = iline(ji)
!    endif
!  enddo
!
!  call find_gauche_droite(iline2)  
!  write(12,rec=jj) iline2
!  iline = iline2
! 
!enddo
!
!close(11)
!close(12)


! les autres
do iinter = ninter1,ninter2,2

do jiter = 1,niter

!en descendant
  if (iinter==ninter1.and.jiter==1) then
    open(11,file=trim(yname1),form='unformatted',access='direct',recl=ncols)
    open(12,file=trim(yname2),form='unformatted',access='direct',recl=ncols)
  else
    open(11,file=trim(yname2),form='unformatted',access='direct',recl=ncols)
    open(12,file=trim(yname3),form='unformatted',access='direct',recl=ncols)
  endif
  
  do jj=1,iinter
    read(11,rec=jj) iline3in(:,jj)
  enddo

  do jj=1,iinter/2
  
    call find_voisin(iinter,jj,iline3in,iline3out)
    write(12,rec=jj) iline3out(:)

  enddo

  do jj=iinter+1,nrows
    !print*,'JJ ',iinter,jiter,yname3,jj,nrows
  
    iline3in(:,1:iinter-1) = iline3in(:,2:iinter)
    read(11,rec=jj) iline3in(:,iinter)
    jinter = iinter/2
    call find_voisin(iinter,jinter,iline3in,iline3out)
    write(12,rec=jj-jinter) iline3out(:)

  enddo

  do jj=nrows-iinter/2+1,nrows
    call find_voisin(iinter,jj-nrows+iinter,iline3in,iline3out)
    write(12,rec=jj) iline3out(:)

  enddo

  close(11)
  close(12)

  if (iinter/=ninter1.or.jiter/=1) then
    yname1 = yname3 !stockage de celui qu'on vient d'écrire dans yname1
    yname3 = yname2 ! celui qu'on va réécrire est celui qu'on vient de lire
    yname2 = yname1 ! celui qu'on va lire est celui qu'on vient d'écrire
  endif
 
!      
!  !en montant
!  open(11,file=yname3,form='unformatted',access='direct',recl=ncols)
!  print*,yname2
!  open(12,file=yname2,form='unformatted',access='direct',recl=ncols)
!
!  ! on lit les iinter dernières lignes
!  do jj=nrows,nrows-iinter+1,-1
!     ! la ligne nrows est contenue dans l'indice iinter
!    read(11,rec=jj) iline3(:,jj-nrows+iinter)
!  enddo
!
!  ! on commence par les ligne nrows => nrows - iinter/2+1
!  do jj=iinter,iinter/2+1,-1
!  
!    !call find_voisin(iinter,jj,iline3)
!    ! on l'écrit dans la ligne correspondante
!    write(12,rec=jj+nrows-iinter) iline3(:,jj)
!
!  enddo
!
!  ! on lit toutes les autres lignes du fichiers
!  do jj=nrows-iinter,1,-1
!  
!    iline3(:,2:iinter) = iline3(:,1:iinter-1)
!    read(11,rec=jj) iline3(:,1)
!    jinter = iinter/2+1
!    !call find_voisin(iinter,jinter,iline3)
!    write(12,rec=jj+jinter-1) iline3(:,jinter)
!
!  enddo
!
!  do jj=iinter/2,1,-1
!
!    !call find_voisin(iinter,jj,iline3)
!    write(12,rec=jj) iline3(:,jj)
!
!  enddo
!
!  close(11)
!  close(12)
!
!  yname1 = yname3
!  yname3 = yname2
!  yname2 = yname1

enddo

enddo

!open(11,file=yname2,form='unformatted',access='direct',recl=ncols)
!print*,yname3
!open(12,file=yname3,form='unformatted',access='direct',recl=ncols)
!
!do jj=1,nrows
!  read(11,rec=jj) iline
!
!  do ji=1,ncols
!    if (iline(ji)==4) iline(ji) = 2
!  enddo
!
!  write(12,rec=jj) iline
! 
!enddo
!
!  close(11)
!  close(12)

contains

        subroutine find_voisin(kinter,kj,kline2d,klineout)

integer*2, intent(in) :: kinter
integer*4, intent(in) :: kj
integer*1, dimension(:,:), intent(inout) :: kline2d
integer*1, dimension(:), intent(out) :: klineout
integer*2 :: icpt
real*4 :: zval

klineout(:) = kline2d(:,kj)
!
do ji = 1,ncols
  if (kline2d(ji,kj)==0) then
    ! on cherche le plus proche point avec une valeur valide
    do j1=1,kinter/2
      icpt = 0
      zval = 0.
      do j2=-j1,j1
        do j3=-j1,j1
          i0 = ji+j2
          j0 = kj+j3
          if (i0>=1 .and. i0<=ncols .and. j0>=1 .and. j0<=kinter) then
            if (kline2d(i0,j0)/=0) then
              icpt = icpt+1
              zval = zval + kline2d(i0,j0)
            endif
          endif
        enddo
      enddo
      zval = zval / icpt
      klineout(ji) = nint(zval)
    enddo
  endif
enddo

                end subroutine find_voisin


        subroutine find_gauche_droite(kline)

integer*1, dimension(:), intent(inout) :: kline

do ji=1,ncols

  if (kline(ji)==3.or.kline(ji)==1) then

    !gauche
    if (ji>1) then
      do j1=ji-1,1,-1
        if (kline(j1)==4) then
          kline(j1)=kline(ji)
        else
          exit
        endif
      enddo
    endif

    !droite
    if (ji<ncols) then
      do j1=ji+1,ncols
        if (kline(j1)==4) then
          kline(j1)=kline(ji)
        else
          exit
        endif
      enddo
    endif

  endif

enddo

end subroutine find_gauche_droite

      END
