IMPLICIT NONE

integer*2, dimension(253,5) :: isfao
integer*4, dimension(253,3) :: isnew
integer*2 :: inum, jj
integer*8, dimension(3) :: iinter

isnew(:,:) = 0
open(11,file='stats_first_crop_iso3b',form='formatted')
do jj=1,774
  read(11,fmt=*) iinter
  if(iinter(1)>=1 .and. iinter(1)<=253 .and. iinter(2)>0) then
    isnew(iinter(1),iinter(2)) = iinter(3)
  endif
enddo
close(11)

do jj=1,253
  isnew(jj,1:2) = nint(isnew(jj,1:2)*100. / max(1,sum(isnew(jj,1:2))))
enddo

open(14,file='first_crops_c3_pays2.txt',form='formatted')
open(15,file='first_crops_c4_pays2.txt',form='formatted')
open(16,file='first_crops_lig_pays2.txt',form='formatted')
do jj=1,253
  write(14,fmt='(i3.3,a1,i3.3,a1,i3.3,a1,i3.3)') &
          jj,':',jj,':',isnew(jj,1),':',isnew(jj,1)
  write(15,fmt='(i3.3,a1,i3.3,a1,i3.3,a1,i3.3)') &
          jj,':',jj,':',isnew(jj,2),':',isnew(jj,2)
  write(16,fmt='(i3.3,a1,i3.3,a1,i3.3,a1,i3.3)') &
          jj,':',jj,':',isnew(jj,3),':',isnew(jj,3)
enddo  
close(14)
close(15)
close(16)


open(12,file='stats_iso_new_crop',form='formatted')
isnew(:,:) = 0
do jj=1,752
  read(12,fmt=*) iinter
  if(iinter(1)>=1 .and. iinter(1)<=253 .and. iinter(2)>0) then
    isnew(iinter(1),iinter(2)) = iinter(3)
  endif
enddo
close(12)

do jj=1,253
  isnew(jj,1:2) = nint(isnew(jj,1:2)*100. / max(1,sum(isnew(jj,1:2))))
enddo

open(15,file='new_crops_c4_pays.txt',form='formatted')
do jj=1,253
  write(15,fmt='(i3.3,a1,i3.3,a1,i3.3,a1,i3.3)') &
          jj,':',jj,':',isnew(jj,2),':',isnew(jj,2)
enddo  
close(15)

open(12,file='stats_iso3_new_crop2',form='formatted')
isnew(:,:) = 0
do jj=1,953
  read(12,fmt=*) iinter
  if(iinter(1)>=1 .and. iinter(1)<=253 .and. iinter(2)>0 .and. iinter(2)<=3) then
    isnew(iinter(1),iinter(2)) = iinter(3)
  endif
enddo
close(12)

do jj=1,253
  isnew(jj,1:3) = nint(isnew(jj,1:3)*100. / max(1,sum(isnew(jj,1:3))))
enddo

open(15,file='new_crops_c3e_pays.txt',form='formatted')
do jj=1,253
  write(15,fmt='(i3.3,a1,i3.3,a1,i3.3,a1,i3.3)') &
          jj,':',jj,':',isnew(jj,2),':',isnew(jj,2)
enddo  
close(15)


print*,isnew(10,:)
open(12,file='stats_fao',form='formatted')
read(12,fmt=*) inum, isfao(1,:)
do jj=1,253
  read(12,fmt=*) inum, isfao(inum,:)
enddo
close(12)

open(13,file='stats_comparees2.txt',form='formatted')
do jj=1,253
  write(13,*) jj,sum(isfao(jj,1:2)),isnew(jj,1),isfao(jj,3),&
          isnew(jj,2),isfao(jj,4),isnew(jj,3)
enddo
close(13)

      END
